// Script layout for BVQX 2.2 generated by ScriptFromUI Plugin
// NOTE: Instead of "dlg.findChild()" we use "bvqx.FindChild()" since "findChild" is currently not working with script extensions

var bvqx = BrainVoyager; // use short symbol to access BrainVoyager API

var scriptObj = new Object;
scriptObj.scriptNameForUser = "VOI2POI"; // NOT relevant for Plugin GUI script - specify name by which script will be shown to user (e.g. in menu)
scriptObj.dialogFileName    = "VOI2POI.ui"; // specify name of file that will be used by BVQX to create your UI
scriptObj.dialogAccessName  = "PluginDialog"; // specify the name you want to use for accessing your UI

// Initializing global variables for GUI elements
// push buttons
var pbtnCancel, pbtnStart;
// check boxes
var chkBoxNoOverlap, chkBoxLargestPatch, chkBoxFillHoles;
// spin boxes
var dspBoxFrom, dspBoxTo, dspBoxStepsize;
// dialog itself
var dlg;


scriptObj.initDlg = function()
{
   dlg = this.PluginDialog; // less to write
   // find push buttons
   pbtnCancel = bvqx.FindChild("pbtnCancel");
   pbtnStart = bvqx.FindChild("pbtnStart");
   // find check boxes
   chkBoxNoOverlap = bvqx.FindChild("chkBoxNoOverlap");
   chkBoxLargestPatch = bvqx.FindChild("chkBoxLargestPatch");
   chkBoxFillHoles = bvqx.FindChild("chkBoxFillHoles");
   // find spin boxes
   dspBoxFrom = bvqx.FindChild("dspBoxFrom");
   dspBoxTo = bvqx.FindChild("dspBoxTo");
   spBoxNrSmooth = bvqx.FindChild("spBoxNrSmooth");

   // connec UI elements to script functions - you need to know the names of your elements (check your definition)
   pbtnCancel.clicked.connect(this, this.clicked_pbtnCancel);
   pbtnStart.clicked.connect(this, this.clicked_pbtnStart);
}


scriptObj.clicked_pbtnStart = function()
{
   bvqx.PrintToLog("Script>  Dialog's Start button clicked");

   bvqx.SetPluginStringParameter("Command", "Start");

   bvqx.SetPluginIntParameter("NoOverlap", chkBoxNoOverlap.checked);
   bvqx.SetPluginIntParameter("LargestPatch", chkBoxLargestPatch.checked);
   bvqx.SetPluginIntParameter("FillHoles", chkBoxFillHoles.checked);
   
   bvqx.SetPluginFloatParameter("From", dspBoxFrom.value);
   bvqx.SetPluginFloatParameter("To", dspBoxTo.value);
   bvqx.SetPluginIntParameter("NrSmooth", spBoxNrSmooth.value);
   
   dlg.close();
   
   bvqx.ExecutePlugin();
}


scriptObj.clicked_pbtnCancel = function()
{
   bvqx.PrintToLog("Script>  Dialog's Cancel button clicked");

   dlg.close();
}


returnScriptObj = function()
{
   return scriptObj; // it is important to return script object containing properties and functions to be called from BrainVoyager QX
}
returnScriptObj();
